% Exercise "Terminal constraint and region of attraction" part (c)

% Define model, cost function, and bounds.
A = [2, 1; 0, 2];
B = [1, 0; 0, 1];
N = 3;

alpha = 1e-5;
Q = alpha*eye(2);
R = eye(2);

K = zeros(size(B')); % Don't actually use this, but it's needed for findXn().

% Bounds.
xlb = [-inf(); -inf()];
xub = [5; inf()];
ulb = [-1; -1];
uub = [1; 1];

% Find region of stability.
[Xn, V, Z] = findXn(A, B, K, N, xlb, xub, ulb, uub, 'termeq');

% Compute lines.
function l = vertices2lines(p, xlims, ylims)
    % l = vertices2lines(p, xlims, ylims)
    %
    % Returns 2-column array of line segments corresponding to edges of the
    % polygon with vertices in columns of p (which must be in the proper order).
    % Each line segment has 101 interpolation points (to make gnuplot happy),
    % and there is a row of NaNs inserted between each line.
    dp = diff(p, 1, 2);
    N = size(p, 2) - 1;
    blocks = cell(N, 1);
    xlims = linspace(xlims(1), xlims(2), 101)';
    ylims = linspace(ylims(1), ylims(2), 101)';
    for i = 1:N
        slope = dp(2,i)/dp(1,i);
        if isinf(slope) || isnan(slope)
            x = p(1,i)*[1; 1];
            y = ylims;
        else
            x = xlims;
            y = slope*(xlims - p(1,i)) + p(2,i);
        end
        blocks{i} = [[x, y]; NaN(1, 2)];
    end
    l = vertcat(blocks{:});
endfunction

p = V{end}; % Vertices of Xn.
xlims = [-3, 3];
ylims = [-3, 3];
Xnlines = vertices2lines(p, xlims, ylims);

% Save data files.
p = p'; % Vertices of Xn. 'Xnterminal_c.dat'
l = Xnlines; % Lines for all sides. 'Xnterminal_lines_c.dat'
save('Xnterminal_c.dat', 'p', 'l');
